
#ifndef __EVA4CAP_LIB_H_____
#define __EVA4CAP_LIB_H_____

#include "eepreport.h"


#ifdef __cplusplus
extern "C" {
#endif

#define	BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long


enum {
	VM_FULL_YUV_I=0,
	VM_FULL_YUV_NI,
	VM_FULL_MONO_I,
	VM_FULL_MONO_NI,
	VM_HALF_YUV_ODD,
	VM_HALF_MONO_ODD,
	VM_HALF_YUV_EVEN,
	VM_HALF_MONO_EVEN,
	VM_HALF_YUV_ODD_EVEN,
	VM_HALF_MONO_ODD_EVEN
};




__declspec( dllexport ) BOOL EVA_Init();
__declspec( dllexport ) BOOL EVA_End();

__declspec( dllexport ) int EVA_GetMaxChannels();

__declspec( dllexport ) int EVA_WriteReg(DWORD offset,DWORD data);
__declspec( dllexport ) int EVA_ReadReg(DWORD offset,DWORD *data);

__declspec( dllexport ) BYTE *EVA_DmaAlloc(int channel,DWORD size);
__declspec( dllexport ) void EVA_DmaFree(int channel);

__declspec( dllexport ) int EVA_GetDmaPos(int channel,DWORD *pos);
__declspec( dllexport ) int EVA_GetDmaPosOvl(int channel,DWORD *pos);

__declspec( dllexport ) int EVA_CancelGetDmaPos(int channel);
__declspec( dllexport ) int EVA_WaitForDmaEnd(int channel);
__declspec( dllexport ) int EVA_DmaStop(int channel);
__declspec( dllexport ) int EVA_DmaRead(int channel,DWORD intlength,DWORD length);
__declspec( dllexport ) int EVA_DmaReadInter(int channel,DWORD intlength,DWORD length,DWORD interlength);

__declspec( dllexport ) void EVA_SetCapMode(int channel,int start,int cap_width,int cap_height,int cap_frames,int cap_ntsc_pal,int cap_mode);
__declspec( dllexport ) int EVA_DmaCapStart(int channel);
__declspec( dllexport ) int EVA_CapEnable(DWORD channels);


// eeprom program 

__declspec( dllexport ) void EVA_SetRpt(eepReport *report);
__declspec( dllexport ) int EVA_Prog(char *filename);

// i2c control functions

__declspec( dllexport ) void EVA_I2cInit();
__declspec( dllexport ) void EVA_I2cClr();
__declspec( dllexport ) int EVA_I2cWrite( BYTE chan,BYTE chip_addr,BYTE  sub_addr,BYTE length, BYTE *buffer);
__declspec( dllexport ) int EVA_I2cRead(BYTE chan, BYTE chip_addr,BYTE sub_addr, BYTE *dout);



// image conversion functions
__declspec( dllexport ) void EVA_MakeBMPHeader(BITMAPINFOHEADER *pbmiHdr, BITMAPFILEHEADER *pbmfHdr,int Width,int Height);
__declspec( dllexport ) void EVA_MONOtoBMPImage(BYTE *rawImage, BYTE *bmpImage,int Width,int Height);
__declspec( dllexport ) void EVA_YUVtoBMPImage(BYTE *rawImage, BYTE *bmpImage,int Width,int Height);

// 
__declspec( dllexport ) void EVA_MakeBMPHeaderCh(int channel,BITMAPINFOHEADER *pbmiHdr, BITMAPFILEHEADER *pbmfHdr);
__declspec( dllexport ) void EVA_RAWtoBMPImage(int channel,BYTE *rawImage, BYTE *bmpImage, int pos);

#ifdef __cplusplus
}
#endif

#endif





